# RCSid:
#	$Id: getAuth.pl,v 1.7 2001/08/30 07:48:36 sjg Exp $
#
#	@(#)Copyright (c) 1997-2001 Simon J. Gerraty.
#	All rights reserved.
#	
#	This software is the property of Simon J. Gerraty.
#	It may be used only in accordance with the conditions outlined
#	in the accompanying LICENSE file. If your distribution does
#	not contain a LICENSE file, then you have no rights to use
#	this software and should contact sales@crufty.net to obtain a
#	licensed distribution.
#	
#	This software is provided "AS IS" in the hope that it will be
#	of use.  Since it is not possible to anticipate all possible
#	use of this software, there is absolutely NO WARRANTY.
#
#	Please forward bug reports and fixes to help@crufty.net
#

sub getAuthB4 {
  local($doit);
  local($n,$h,@f);
  %AuthNets = ();
  %Auth = ();
  
  if ( -e $NamedBoot && 
      open(N, "< $NamedBoot")) {
    while (<N>) {
      chop;
      next unless (m/^(primary|secondary)/i);
      $doit = (m/^primary/i) ? 1 : -1;
      @f = split(/\s+/);
      if (m/in-addr/i) {
	$n = $f[$#f];
	next unless ($n =~ m/[1-9.]+/); # skip named.local etc
	$n =~ s/[^1-9]+//;
	$n =~ s/([1-9.]+[1-9]+).*/\1/;
        $AuthNets{"$n"} = $doit;
      }
      $n = "$f[1].";		# zone name
      $n =~ y/A-Z/a-z/;		# lower case
      $n =~ s/\.+/./;		# only one trailing .
      if ($doit > 0) {		# primary
	$Auth{$n} = $f[$#f];	# file
      } else {
	$Auth{$n} = $f[2];	# server
	# record secondaries as well.
	for ($h = 3; $h <= $#f; $h++) {
	  $Auth{$n} .= " $f[$h]" unless (-f $f[$h]);
	}
      }
    }
    close N;
    $AuthNets{"127.0.0"} = -1;
    $AuthNets{"127"} = -1;
  }
}

sub doZone {
  local(*F, $zone) = @_;
  local($nest) = 1;
  local($file,$type,$masters);

  $file = $type = $masters = '';
  $zone .= '.';
  $zone =~ y/A-Z/a-z/;
  $zone =~ s/\.+/./;
  
  while (<F>) {
    chop;
    if (m/type\s+(\S+);/) {
      $type = $1;
    }
    if (m/masters\s+\{(.*)\}/) {
      $masters = $1;
    } 
    if (m/file\s+"(\S+)"/) {
      $file = $1;
    }
    $nest++ if (m/\{/);
    $nest-- if (m/\}/);
    last if ($nest < 1);
  }
  if ($type ne 'hint') {
    if ($type eq 'master') {
      $Auth{$zone} = $file;
    } else {
      $Auth{$zone} = $masters;
    }
    if ($zone =~ m/in-addr/) {
      $n = $file;
      $n =~ s,.*/([\d.]+\d).*,$1.0.0.0,;
      $n =~ s,^(\d+(\.\d+){3}).*,$1,;
      $AuthNets{$n} = ($type eq 'master') ? 1 : -1;
    }
  }
}

sub getAuthZones {
  local($file) = @_;
  local($F) = $file;
  
  $F =~ s,[/.],,g;
  eval {
    if (open($F, "< $file")) {
      while (<$F>) {
	chop;
	if (m/^\s*directory\s+"(\S+)"/) {
#	  $DnsDir=$1;
	  next;
	}
	if (m/^\s*zone\s+"(\S+)"/) {
	  eval "&doZone(\*$F, \$1)";
	  next;
	}
	if (m/^\s*include\s+"(\S+)"/) {
	  &getAuthZones($1); # recurse
	  next;
	}
      }
      close $F;
    }
  }
}

sub getAuthB8 {
  local($doit);
  local($n,$h,@f);
  %AuthNets = ();
  %Auth = ();
  
  if (-e $NamedBoot) {
    &getAuthZones($NamedBoot);
    # These are taken care of
    $AuthNets{"127.0.0"} = -1;
    $AuthNets{"127"} = -1;
  }
}

sub getAuth {
  local($ndboot) = @_;
  %AuthNets = ();
  %Auth = ();

  if ($ndboot ne '' && -e $ndboot) {
    $NamedBoot = $ndboot;
  }
  if ($NamedBoot =~ m/named.*\.conf/) {
    $Bind8 = 1;
    &getAuthB8;
  } else {
    &getAuthB4;
  }
}

1;
