# RCSid:
#	$Id: ip_subs.pl,v 1.3 2001/08/30 07:48:37 sjg Exp $
#
#	@(#) Copyright (c) 1993 Simon J. Gerraty
#
#	This file is provided in the hope that it will
#	be of use.  There is absolutely NO WARRANTY.
#	Permission to copy, redistribute or otherwise
#	use this file is hereby granted provided that 
#	the above copyright notice and this notice are
#	left intact. 
#      
#	Please send copies of changes and bug-fixes to:
#	sjg@crufty.net
#

sub net2class_mask {
  local(@a) = split(/\./, $_[0]);
  local($mask);
  
  if ($a[0] < 128) {
    $mask = 0xff000000;
  } elsif ($a[0] < 192) {
    $mask = 0xffff0000;
  } else {
    $mask = 0xffffff00;
  }
  $mask;
}

sub net2mask {
  local($mask);
  
  if ($opt_m ne '') {
    if ($opt_m =~ m/\./) {
      $mask = &ip2hex($opt_m);
    } else {
      $mask = hex($opt_m);
    }
  } else {
    $mask = &net2class_mask(@_);
  }
  $mask;
}

sub ip2hex {
  local(@a) = split(/\./, $_[0]);
  local($i,$net);
  
  for ($net = 0, $i = 0; $i < 4; $i++) {
    $net <<= 8;
    $net += $a[$i];
  }
  $net;
}

sub hex2ip {
  local($net,$mask) = @_;
  local($msk);
  local(@a,@m);
  local($i,$j);

  @a = ();
  $mask = 0xffffffff unless ($mask ne '');
  $net &= $mask;
  # this messy algorithm allows returning only part of an address
  for ($i = 0, $j = 0; $i < 4; $i++) {
    $msk = 0xff000000 >> (8 * $i);
    next unless ($mask & $msk);
    $a[$j++] = $net >> (8 * (3 - $i)) & 0xff;
  }
  join('.', @a);
}

sub ip2net_host {
  local($addr,$mask) = @_;
  local($net,$hn);

  $mask = &net2mask($addr) if ($mask eq '');
  $net = &ip2hex($addr);
  $nn = &hex2ip($net, $mask);
  $hn = &hex2ip($net, ~$mask);
  ($nn, $hn);
}

1;
